/* This file was generated by plugin 'Nordic Semiconductor nRF5x v.1.2.2' (BDS version 1.1.3139.0) */

#ifndef BLE_QUICKDRAW_H__
#define BLE_QUICKDRAW_H__

#include <stdint.h>
#include <stdbool.h>
#include "ble.h"
#include "ble_srv_common.h"
#include "app_util_bds.h"



/**@brief quickdraw event type. */
typedef enum
{ 
    BLE_QUICKDRAW_XYZ_EVT_NOTIFICATION_ENABLED,  /**< xyz value notification enabled event. */
    BLE_QUICKDRAW_XYZ_EVT_NOTIFICATION_DISABLED, /**< xyz value notification disabled event. */
    BLE_QUICKDRAW_XYZ_EVT_CCCD_WRITE, /**< xyz CCCD write event. */
} ble_quickdraw_evt_type_t;

// Forward declaration of the ble_quickdraw_t type.
typedef struct ble_quickdraw_s ble_quickdraw_t;








/**@brief xyz structure. */
typedef struct
{
    int16_t x;
    int16_t y;
    int16_t z;
} ble_quickdraw_xyz_t;

/**@brief quickdraw Service event. */
typedef struct
{
    ble_quickdraw_evt_type_t evt_type;    /**< Type of event. */
    union {
        uint16_t cccd_value; /**< Holds decoded data in Notify and Indicate event handler. */
    } params;
} ble_quickdraw_evt_t;

/**@brief quickdraw Service event handler type. */
typedef void (*ble_quickdraw_evt_handler_t) (ble_quickdraw_t * p_quickdraw, ble_quickdraw_evt_t * p_evt);

/**@brief quickdraw Service init structure. This contains all options and data needed for initialization of the service */
typedef struct
{
    ble_quickdraw_evt_handler_t     evt_handler; /**< Event handler to be called for handling events in the quickdraw Service. */
    bool is_xyz_read_supported; /**< TRUE if read of xyz is supported. */
    ble_quickdraw_xyz_t ble_quickdraw_xyz_initial_value; /**< If not NULL, initial value of the xyz characteristic. */ 
} ble_quickdraw_init_t;

/**@brief quickdraw Service structure. This contains various status information for the service.*/
struct ble_quickdraw_s
{
    ble_quickdraw_evt_handler_t evt_handler; /**< Event handler to be called for handling events in the quickdraw Service. */
    uint16_t service_handle; /**< Handle of quickdraw Service (as provided by the BLE stack). */
    bool is_xyz_read_supported; /**< TRUE if read of xyz is supported. */
    ble_gatts_char_handles_t xyz_handles; /**< Handles related to the xyz characteristic. */
    uint16_t conn_handle; /**< Handle of the current connection (as provided by the BLE stack, is BLE_CONN_HANDLE_INVALID if not in a connection). */
};

/**@brief Function for initializing the quickdraw.
 *
 * @param[out]  p_quickdraw       quickdraw Service structure. This structure will have to be supplied by
 *                          the application. It will be initialized by this function, and will later
 *                          be used to identify this particular service instance.
 * @param[in]   p_quickdraw_init  Information needed to initialize the service.
 *
 * @return      NRF_SUCCESS on successful initialization of service, otherwise an error code.
 */
uint32_t ble_quickdraw_init(ble_quickdraw_t * p_quickdraw, const ble_quickdraw_init_t * p_quickdraw_init);

/**@brief Function for handling the Application's BLE Stack events.*/
void ble_quickdraw_on_ble_evt(ble_quickdraw_t * p_quickdraw, ble_evt_t * p_ble_evt);

/**@brief Function for setting the xyz.
 *
 * @details Sets a new value of the xyz characteristic. The new value will be sent
 *          to the client the next time the client reads the xyz characteristic.
 *          This function is only generated if the characteristic's Read property is not 'Excluded'.
 *
 * @param[in]   p_quickdraw                 quickdraw Service structure.
 * @param[in]   p_xyz  New xyz.
 *
 * @return      NRF_SUCCESS on success, otherwise an error code.
 */
uint32_t ble_quickdraw_xyz_set(ble_quickdraw_t * p_quickdraw, ble_quickdraw_xyz_t * p_xyz);

/**@brief Function for sending the xyz.
 *
 * @details The application calls this function after having performed a xyz.
 *          The xyz data is encoded and sent to the client.
 *          This function is only generated if the characteristic's Notify or Indicate property is not 'Excluded'.
 *
 * @param[in]   p_quickdraw                    quickdraw Service structure.
 * @param[in]   p_xyz               New xyz.
 *
 * @return      NRF_SUCCESS on success, otherwise an error code.
 */
uint32_t ble_quickdraw_xyz_send(ble_quickdraw_t * p_quickdraw, ble_quickdraw_xyz_t * p_xyz);

#endif //_BLE_QUICKDRAW_H__
